import { Ref } from 'vue'
import { CommonTableColumn } from '~/common'

export default function useTableColumnSet(
  tableColumns: Ref<CommonTableColumn[]>
) {
  const filterColumnKeys = ref<string[]>([])
  const filteredColumns = computed(() =>
    tableColumns.value.filter(({ columnName }) =>
      filterColumnKeys.value.includes(columnName)
    )
  )
  const columnChecked = (checkedColumnKeys: string[]) => {
    filterColumnKeys.value = checkedColumnKeys
  }
  return {
    columnChecked,
    filteredColumns,
  }
}
